/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x010c0d, CODE_FOR_extendqihi2 },
  { 0x010c0e, CODE_FOR_extendqisi2 },
  { 0x010c0f, CODE_FOR_extendqidi2 },
  { 0x010d0e, CODE_FOR_extendhisi2 },
  { 0x010d0f, CODE_FOR_extendhidi2 },
  { 0x010e0f, CODE_FOR_extendsidi2 },
  { 0x012627, CODE_FOR_extendhfsf2 },
  { 0x012628, CODE_FOR_extendhfdf2 },
  { 0x012728, CODE_FOR_extendsfdf2 },
  { 0x022726, CODE_FOR_truncsfhf2 },
  { 0x022826, CODE_FOR_truncdfhf2 },
  { 0x022827, CODE_FOR_truncdfsf2 },
  { 0x030c0d, CODE_FOR_zero_extendqihi2 },
  { 0x030c0e, CODE_FOR_zero_extendqisi2 },
  { 0x030c0f, CODE_FOR_zero_extendqidi2 },
  { 0x030d0e, CODE_FOR_zero_extendhisi2 },
  { 0x030d0f, CODE_FOR_zero_extendhidi2 },
  { 0x030e0f, CODE_FOR_zero_extendsidi2 },
  { 0x04513b, CODE_FOR_fixv2sfv2si2 },
  { 0x04543e, CODE_FOR_fixv4sfv4si2 },
  { 0x04553f, CODE_FOR_fixv2dfv2di2 },
  { 0x05513b, CODE_FOR_fixunsv2sfv2si2 },
  { 0x05543e, CODE_FOR_fixunsv4sfv4si2 },
  { 0x05553f, CODE_FOR_fixunsv2dfv2di2 },
  { 0x060e27, CODE_FOR_floatsisf2 },
  { 0x060e28, CODE_FOR_floatsidf2 },
  { 0x060f27, CODE_FOR_floatdisf2 },
  { 0x060f28, CODE_FOR_floatdidf2 },
  { 0x063b51, CODE_FOR_floatv2siv2sf2 },
  { 0x063e54, CODE_FOR_floatv4siv4sf2 },
  { 0x063f55, CODE_FOR_floatv2div2df2 },
  { 0x070e27, CODE_FOR_floatunssisf2 },
  { 0x070e28, CODE_FOR_floatunssidf2 },
  { 0x070f27, CODE_FOR_floatunsdisf2 },
  { 0x070f28, CODE_FOR_floatunsdidf2 },
  { 0x073b51, CODE_FOR_floatunsv2siv2sf2 },
  { 0x073e54, CODE_FOR_floatunsv4siv4sf2 },
  { 0x073f55, CODE_FOR_floatunsv2div2df2 },
  { 0x09270e, CODE_FOR_lroundsfsi2 },
  { 0x09270f, CODE_FOR_lroundsfdi2 },
  { 0x09280e, CODE_FOR_lrounddfsi2 },
  { 0x09280f, CODE_FOR_lrounddfdi2 },
  { 0x09513b, CODE_FOR_lroundv2sfv2si2 },
  { 0x09543e, CODE_FOR_lroundv4sfv4si2 },
  { 0x09553f, CODE_FOR_lroundv2dfv2di2 },
  { 0x0a270e, CODE_FOR_lfloorsfsi2 },
  { 0x0a270f, CODE_FOR_lfloorsfdi2 },
  { 0x0a280e, CODE_FOR_lfloordfsi2 },
  { 0x0a280f, CODE_FOR_lfloordfdi2 },
  { 0x0a513b, CODE_FOR_lfloorv2sfv2si2 },
  { 0x0a543e, CODE_FOR_lfloorv4sfv4si2 },
  { 0x0a553f, CODE_FOR_lfloorv2dfv2di2 },
  { 0x0b270e, CODE_FOR_lceilsfsi2 },
  { 0x0b270f, CODE_FOR_lceilsfdi2 },
  { 0x0b280e, CODE_FOR_lceildfsi2 },
  { 0x0b280f, CODE_FOR_lceildfdi2 },
  { 0x0b513b, CODE_FOR_lceilv2sfv2si2 },
  { 0x0b543e, CODE_FOR_lceilv4sfv4si2 },
  { 0x0b553f, CODE_FOR_lceilv2dfv2di2 },
  { 0x10270e, CODE_FOR_fix_truncsfsi2 },
  { 0x10270f, CODE_FOR_fix_truncsfdi2 },
  { 0x10280e, CODE_FOR_fix_truncdfsi2 },
  { 0x10280f, CODE_FOR_fix_truncdfdi2 },
  { 0x10513b, CODE_FOR_fix_truncv2sfv2si2 },
  { 0x10543e, CODE_FOR_fix_truncv4sfv4si2 },
  { 0x10553f, CODE_FOR_fix_truncv2dfv2di2 },
  { 0x11270e, CODE_FOR_fixuns_truncsfsi2 },
  { 0x11270f, CODE_FOR_fixuns_truncsfdi2 },
  { 0x11280e, CODE_FOR_fixuns_truncdfsi2 },
  { 0x11280f, CODE_FOR_fixuns_truncdfdi2 },
  { 0x11513b, CODE_FOR_fixuns_truncv2sfv2si2 },
  { 0x11543e, CODE_FOR_fixuns_truncv4sfv4si2 },
  { 0x11553f, CODE_FOR_fixuns_truncv2dfv2di2 },
  { 0x120e0f, CODE_FOR_mulsidi3 },
  { 0x120f10, CODE_FOR_mulditi3 },
  { 0x130e0f, CODE_FOR_umulsidi3 },
  { 0x130f10, CODE_FOR_umulditi3 },
  { 0x150e0f, CODE_FOR_maddsidi4 },
  { 0x160e0f, CODE_FOR_umaddsidi4 },
  { 0x190e0f, CODE_FOR_msubsidi4 },
  { 0x1a0e0f, CODE_FOR_umsubsidi4 },
  { 0x1d3c11, CODE_FOR_vec_load_lanesoiv16qi },
  { 0x1d3c12, CODE_FOR_vec_load_lanesciv16qi },
  { 0x1d3c13, CODE_FOR_vec_load_lanesxiv16qi },
  { 0x1d3d11, CODE_FOR_vec_load_lanesoiv8hi },
  { 0x1d3d12, CODE_FOR_vec_load_lanesciv8hi },
  { 0x1d3d13, CODE_FOR_vec_load_lanesxiv8hi },
  { 0x1d3e11, CODE_FOR_vec_load_lanesoiv4si },
  { 0x1d3e12, CODE_FOR_vec_load_lanesciv4si },
  { 0x1d3e13, CODE_FOR_vec_load_lanesxiv4si },
  { 0x1d3f11, CODE_FOR_vec_load_lanesoiv2di },
  { 0x1d3f12, CODE_FOR_vec_load_lanesciv2di },
  { 0x1d3f13, CODE_FOR_vec_load_lanesxiv2di },
  { 0x1d5311, CODE_FOR_vec_load_lanesoiv8hf },
  { 0x1d5312, CODE_FOR_vec_load_lanesciv8hf },
  { 0x1d5313, CODE_FOR_vec_load_lanesxiv8hf },
  { 0x1d5411, CODE_FOR_vec_load_lanesoiv4sf },
  { 0x1d5412, CODE_FOR_vec_load_lanesciv4sf },
  { 0x1d5413, CODE_FOR_vec_load_lanesxiv4sf },
  { 0x1d5511, CODE_FOR_vec_load_lanesoiv2df },
  { 0x1d5512, CODE_FOR_vec_load_lanesciv2df },
  { 0x1d5513, CODE_FOR_vec_load_lanesxiv2df },
  { 0x1e3c11, CODE_FOR_vec_store_lanesoiv16qi },
  { 0x1e3c12, CODE_FOR_vec_store_lanesciv16qi },
  { 0x1e3c13, CODE_FOR_vec_store_lanesxiv16qi },
  { 0x1e3d11, CODE_FOR_vec_store_lanesoiv8hi },
  { 0x1e3d12, CODE_FOR_vec_store_lanesciv8hi },
  { 0x1e3d13, CODE_FOR_vec_store_lanesxiv8hi },
  { 0x1e3e11, CODE_FOR_vec_store_lanesoiv4si },
  { 0x1e3e12, CODE_FOR_vec_store_lanesciv4si },
  { 0x1e3e13, CODE_FOR_vec_store_lanesxiv4si },
  { 0x1e3f11, CODE_FOR_vec_store_lanesoiv2di },
  { 0x1e3f12, CODE_FOR_vec_store_lanesciv2di },
  { 0x1e3f13, CODE_FOR_vec_store_lanesxiv2di },
  { 0x1e5311, CODE_FOR_vec_store_lanesoiv8hf },
  { 0x1e5312, CODE_FOR_vec_store_lanesciv8hf },
  { 0x1e5313, CODE_FOR_vec_store_lanesxiv8hf },
  { 0x1e5411, CODE_FOR_vec_store_lanesoiv4sf },
  { 0x1e5412, CODE_FOR_vec_store_lanesciv4sf },
  { 0x1e5413, CODE_FOR_vec_store_lanesxiv4sf },
  { 0x1e5511, CODE_FOR_vec_store_lanesoiv2df },
  { 0x1e5512, CODE_FOR_vec_store_lanesciv2df },
  { 0x1e5513, CODE_FOR_vec_store_lanesxiv2df },
  { 0x1f0f0f, CODE_FOR_vconddidi },
  { 0x1f3939, CODE_FOR_vcondv8qiv8qi },
  { 0x1f3a3a, CODE_FOR_vcondv4hiv4hi },
  { 0x1f3b3b, CODE_FOR_vcondv2siv2si },
  { 0x1f3c3c, CODE_FOR_vcondv16qiv16qi },
  { 0x1f3d3d, CODE_FOR_vcondv8hiv8hi },
  { 0x1f3e3e, CODE_FOR_vcondv4siv4si },
  { 0x1f3f3f, CODE_FOR_vcondv2div2di },
  { 0x1f513b, CODE_FOR_vcondv2siv2sf },
  { 0x1f5151, CODE_FOR_vcondv2sfv2sf },
  { 0x1f543e, CODE_FOR_vcondv4siv4sf },
  { 0x1f5454, CODE_FOR_vcondv4sfv4sf },
  { 0x1f553f, CODE_FOR_vcondv2div2df },
  { 0x1f5555, CODE_FOR_vcondv2dfv2df },
  { 0x200f0f, CODE_FOR_vcondudidi },
  { 0x203939, CODE_FOR_vconduv8qiv8qi },
  { 0x203a3a, CODE_FOR_vconduv4hiv4hi },
  { 0x203b3b, CODE_FOR_vconduv2siv2si },
  { 0x203c3c, CODE_FOR_vconduv16qiv16qi },
  { 0x203d3d, CODE_FOR_vconduv8hiv8hi },
  { 0x203e3e, CODE_FOR_vconduv4siv4si },
  { 0x203f3f, CODE_FOR_vconduv2div2di },
  { 0x26000e, CODE_FOR_addsi3 },
  { 0x26000f, CODE_FOR_adddi3 },
  { 0x260010, CODE_FOR_addti3 },
  { 0x260027, CODE_FOR_addsf3 },
  { 0x260028, CODE_FOR_adddf3 },
  { 0x260039, CODE_FOR_addv8qi3 },
  { 0x26003a, CODE_FOR_addv4hi3 },
  { 0x26003b, CODE_FOR_addv2si3 },
  { 0x26003c, CODE_FOR_addv16qi3 },
  { 0x26003d, CODE_FOR_addv8hi3 },
  { 0x26003e, CODE_FOR_addv4si3 },
  { 0x26003f, CODE_FOR_addv2di3 },
  { 0x260051, CODE_FOR_addv2sf3 },
  { 0x260054, CODE_FOR_addv4sf3 },
  { 0x260055, CODE_FOR_addv2df3 },
  { 0x2a000e, CODE_FOR_subsi3 },
  { 0x2a000f, CODE_FOR_subdi3 },
  { 0x2a0010, CODE_FOR_subti3 },
  { 0x2a0027, CODE_FOR_subsf3 },
  { 0x2a0028, CODE_FOR_subdf3 },
  { 0x2a0039, CODE_FOR_subv8qi3 },
  { 0x2a003a, CODE_FOR_subv4hi3 },
  { 0x2a003b, CODE_FOR_subv2si3 },
  { 0x2a003c, CODE_FOR_subv16qi3 },
  { 0x2a003d, CODE_FOR_subv8hi3 },
  { 0x2a003e, CODE_FOR_subv4si3 },
  { 0x2a003f, CODE_FOR_subv2di3 },
  { 0x2a0051, CODE_FOR_subv2sf3 },
  { 0x2a0054, CODE_FOR_subv4sf3 },
  { 0x2a0055, CODE_FOR_subv2df3 },
  { 0x2e000e, CODE_FOR_mulsi3 },
  { 0x2e000f, CODE_FOR_muldi3 },
  { 0x2e0010, CODE_FOR_multi3 },
  { 0x2e0027, CODE_FOR_mulsf3 },
  { 0x2e0028, CODE_FOR_muldf3 },
  { 0x2e0039, CODE_FOR_mulv8qi3 },
  { 0x2e003a, CODE_FOR_mulv4hi3 },
  { 0x2e003b, CODE_FOR_mulv2si3 },
  { 0x2e003c, CODE_FOR_mulv16qi3 },
  { 0x2e003d, CODE_FOR_mulv8hi3 },
  { 0x2e003e, CODE_FOR_mulv4si3 },
  { 0x2e0051, CODE_FOR_mulv2sf3 },
  { 0x2e0054, CODE_FOR_mulv4sf3 },
  { 0x2e0055, CODE_FOR_mulv2df3 },
  { 0x32000e, CODE_FOR_divsi3 },
  { 0x32000f, CODE_FOR_divdi3 },
  { 0x320027, CODE_FOR_divsf3 },
  { 0x320028, CODE_FOR_divdf3 },
  { 0x320051, CODE_FOR_divv2sf3 },
  { 0x320054, CODE_FOR_divv4sf3 },
  { 0x320055, CODE_FOR_divv2df3 },
  { 0x35000e, CODE_FOR_udivsi3 },
  { 0x35000f, CODE_FOR_udivdi3 },
  { 0x39000e, CODE_FOR_modsi3 },
  { 0x39000f, CODE_FOR_moddi3 },
  { 0x3b0051, CODE_FOR_ftruncv2sf2 },
  { 0x3b0054, CODE_FOR_ftruncv4sf2 },
  { 0x3b0055, CODE_FOR_ftruncv2df2 },
  { 0x3c000e, CODE_FOR_andsi3 },
  { 0x3c000f, CODE_FOR_anddi3 },
  { 0x3c0039, CODE_FOR_andv8qi3 },
  { 0x3c003a, CODE_FOR_andv4hi3 },
  { 0x3c003b, CODE_FOR_andv2si3 },
  { 0x3c003c, CODE_FOR_andv16qi3 },
  { 0x3c003d, CODE_FOR_andv8hi3 },
  { 0x3c003e, CODE_FOR_andv4si3 },
  { 0x3c003f, CODE_FOR_andv2di3 },
  { 0x3d000e, CODE_FOR_iorsi3 },
  { 0x3d000f, CODE_FOR_iordi3 },
  { 0x3d0039, CODE_FOR_iorv8qi3 },
  { 0x3d003a, CODE_FOR_iorv4hi3 },
  { 0x3d003b, CODE_FOR_iorv2si3 },
  { 0x3d003c, CODE_FOR_iorv16qi3 },
  { 0x3d003d, CODE_FOR_iorv8hi3 },
  { 0x3d003e, CODE_FOR_iorv4si3 },
  { 0x3d003f, CODE_FOR_iorv2di3 },
  { 0x3e000e, CODE_FOR_xorsi3 },
  { 0x3e000f, CODE_FOR_xordi3 },
  { 0x3e0039, CODE_FOR_xorv8qi3 },
  { 0x3e003a, CODE_FOR_xorv4hi3 },
  { 0x3e003b, CODE_FOR_xorv2si3 },
  { 0x3e003c, CODE_FOR_xorv16qi3 },
  { 0x3e003d, CODE_FOR_xorv8hi3 },
  { 0x3e003e, CODE_FOR_xorv4si3 },
  { 0x3e003f, CODE_FOR_xorv2di3 },
  { 0x3f000c, CODE_FOR_ashlqi3 },
  { 0x3f000d, CODE_FOR_ashlhi3 },
  { 0x3f000e, CODE_FOR_ashlsi3 },
  { 0x3f000f, CODE_FOR_ashldi3 },
  { 0x3f0039, CODE_FOR_ashlv8qi3 },
  { 0x3f003a, CODE_FOR_ashlv4hi3 },
  { 0x3f003b, CODE_FOR_ashlv2si3 },
  { 0x3f003c, CODE_FOR_ashlv16qi3 },
  { 0x3f003d, CODE_FOR_ashlv8hi3 },
  { 0x3f003e, CODE_FOR_ashlv4si3 },
  { 0x3f003f, CODE_FOR_ashlv2di3 },
  { 0x42000e, CODE_FOR_ashrsi3 },
  { 0x42000f, CODE_FOR_ashrdi3 },
  { 0x420039, CODE_FOR_ashrv8qi3 },
  { 0x42003a, CODE_FOR_ashrv4hi3 },
  { 0x42003b, CODE_FOR_ashrv2si3 },
  { 0x42003c, CODE_FOR_ashrv16qi3 },
  { 0x42003d, CODE_FOR_ashrv8hi3 },
  { 0x42003e, CODE_FOR_ashrv4si3 },
  { 0x42003f, CODE_FOR_ashrv2di3 },
  { 0x43000e, CODE_FOR_lshrsi3 },
  { 0x43000f, CODE_FOR_lshrdi3 },
  { 0x430039, CODE_FOR_lshrv8qi3 },
  { 0x43003a, CODE_FOR_lshrv4hi3 },
  { 0x43003b, CODE_FOR_lshrv2si3 },
  { 0x43003c, CODE_FOR_lshrv16qi3 },
  { 0x43003d, CODE_FOR_lshrv8hi3 },
  { 0x43003e, CODE_FOR_lshrv4si3 },
  { 0x43003f, CODE_FOR_lshrv2di3 },
  { 0x44000e, CODE_FOR_rotlsi3 },
  { 0x44000f, CODE_FOR_rotldi3 },
  { 0x45000e, CODE_FOR_rotrsi3 },
  { 0x45000f, CODE_FOR_rotrdi3 },
  { 0x460039, CODE_FOR_vashlv8qi3 },
  { 0x46003a, CODE_FOR_vashlv4hi3 },
  { 0x46003b, CODE_FOR_vashlv2si3 },
  { 0x46003c, CODE_FOR_vashlv16qi3 },
  { 0x46003d, CODE_FOR_vashlv8hi3 },
  { 0x46003e, CODE_FOR_vashlv4si3 },
  { 0x46003f, CODE_FOR_vashlv2di3 },
  { 0x470039, CODE_FOR_vashrv8qi3 },
  { 0x47003a, CODE_FOR_vashrv4hi3 },
  { 0x47003b, CODE_FOR_vashrv2si3 },
  { 0x47003c, CODE_FOR_vashrv16qi3 },
  { 0x47003d, CODE_FOR_vashrv8hi3 },
  { 0x47003e, CODE_FOR_vashrv4si3 },
  { 0x480039, CODE_FOR_vlshrv8qi3 },
  { 0x48003a, CODE_FOR_vlshrv4hi3 },
  { 0x48003b, CODE_FOR_vlshrv2si3 },
  { 0x48003c, CODE_FOR_vlshrv16qi3 },
  { 0x48003d, CODE_FOR_vlshrv8hi3 },
  { 0x48003e, CODE_FOR_vlshrv4si3 },
  { 0x4b0027, CODE_FOR_sminsf3 },
  { 0x4b0028, CODE_FOR_smindf3 },
  { 0x4b0039, CODE_FOR_sminv8qi3 },
  { 0x4b003a, CODE_FOR_sminv4hi3 },
  { 0x4b003b, CODE_FOR_sminv2si3 },
  { 0x4b003c, CODE_FOR_sminv16qi3 },
  { 0x4b003d, CODE_FOR_sminv8hi3 },
  { 0x4b003e, CODE_FOR_sminv4si3 },
  { 0x4b003f, CODE_FOR_sminv2di3 },
  { 0x4b0051, CODE_FOR_sminv2sf3 },
  { 0x4b0054, CODE_FOR_sminv4sf3 },
  { 0x4b0055, CODE_FOR_sminv2df3 },
  { 0x4c0027, CODE_FOR_smaxsf3 },
  { 0x4c0028, CODE_FOR_smaxdf3 },
  { 0x4c0039, CODE_FOR_smaxv8qi3 },
  { 0x4c003a, CODE_FOR_smaxv4hi3 },
  { 0x4c003b, CODE_FOR_smaxv2si3 },
  { 0x4c003c, CODE_FOR_smaxv16qi3 },
  { 0x4c003d, CODE_FOR_smaxv8hi3 },
  { 0x4c003e, CODE_FOR_smaxv4si3 },
  { 0x4c003f, CODE_FOR_smaxv2di3 },
  { 0x4c0051, CODE_FOR_smaxv2sf3 },
  { 0x4c0054, CODE_FOR_smaxv4sf3 },
  { 0x4c0055, CODE_FOR_smaxv2df3 },
  { 0x4d0039, CODE_FOR_uminv8qi3 },
  { 0x4d003a, CODE_FOR_uminv4hi3 },
  { 0x4d003b, CODE_FOR_uminv2si3 },
  { 0x4d003c, CODE_FOR_uminv16qi3 },
  { 0x4d003d, CODE_FOR_uminv8hi3 },
  { 0x4d003e, CODE_FOR_uminv4si3 },
  { 0x4d003f, CODE_FOR_uminv2di3 },
  { 0x4e0039, CODE_FOR_umaxv8qi3 },
  { 0x4e003a, CODE_FOR_umaxv4hi3 },
  { 0x4e003b, CODE_FOR_umaxv2si3 },
  { 0x4e003c, CODE_FOR_umaxv16qi3 },
  { 0x4e003d, CODE_FOR_umaxv8hi3 },
  { 0x4e003e, CODE_FOR_umaxv4si3 },
  { 0x4e003f, CODE_FOR_umaxv2di3 },
  { 0x4f000e, CODE_FOR_negsi2 },
  { 0x4f000f, CODE_FOR_negdi2 },
  { 0x4f0027, CODE_FOR_negsf2 },
  { 0x4f0028, CODE_FOR_negdf2 },
  { 0x4f0039, CODE_FOR_negv8qi2 },
  { 0x4f003a, CODE_FOR_negv4hi2 },
  { 0x4f003b, CODE_FOR_negv2si2 },
  { 0x4f003c, CODE_FOR_negv16qi2 },
  { 0x4f003d, CODE_FOR_negv8hi2 },
  { 0x4f003e, CODE_FOR_negv4si2 },
  { 0x4f003f, CODE_FOR_negv2di2 },
  { 0x4f0051, CODE_FOR_negv2sf2 },
  { 0x4f0054, CODE_FOR_negv4sf2 },
  { 0x4f0055, CODE_FOR_negv2df2 },
  { 0x53000e, CODE_FOR_abssi2 },
  { 0x53000f, CODE_FOR_absdi2 },
  { 0x530027, CODE_FOR_abssf2 },
  { 0x530028, CODE_FOR_absdf2 },
  { 0x530039, CODE_FOR_absv8qi2 },
  { 0x53003a, CODE_FOR_absv4hi2 },
  { 0x53003b, CODE_FOR_absv2si2 },
  { 0x53003c, CODE_FOR_absv16qi2 },
  { 0x53003d, CODE_FOR_absv8hi2 },
  { 0x53003e, CODE_FOR_absv4si2 },
  { 0x53003f, CODE_FOR_absv2di2 },
  { 0x530051, CODE_FOR_absv2sf2 },
  { 0x530054, CODE_FOR_absv4sf2 },
  { 0x530055, CODE_FOR_absv2df2 },
  { 0x55000e, CODE_FOR_one_cmplsi2 },
  { 0x55000f, CODE_FOR_one_cmpldi2 },
  { 0x550039, CODE_FOR_one_cmplv8qi2 },
  { 0x55003a, CODE_FOR_one_cmplv4hi2 },
  { 0x55003b, CODE_FOR_one_cmplv2si2 },
  { 0x55003c, CODE_FOR_one_cmplv16qi2 },
  { 0x55003d, CODE_FOR_one_cmplv8hi2 },
  { 0x55003e, CODE_FOR_one_cmplv4si2 },
  { 0x55003f, CODE_FOR_one_cmplv2di2 },
  { 0x56000d, CODE_FOR_bswaphi2 },
  { 0x56000e, CODE_FOR_bswapsi2 },
  { 0x56000f, CODE_FOR_bswapdi2 },
  { 0x56003a, CODE_FOR_bswapv4hi2 },
  { 0x56003b, CODE_FOR_bswapv2si2 },
  { 0x56003d, CODE_FOR_bswapv8hi2 },
  { 0x56003e, CODE_FOR_bswapv4si2 },
  { 0x56003f, CODE_FOR_bswapv2di2 },
  { 0x57000e, CODE_FOR_ffssi2 },
  { 0x57000f, CODE_FOR_ffsdi2 },
  { 0x58000e, CODE_FOR_clzsi2 },
  { 0x58000f, CODE_FOR_clzdi2 },
  { 0x580039, CODE_FOR_clzv8qi2 },
  { 0x58003a, CODE_FOR_clzv4hi2 },
  { 0x58003b, CODE_FOR_clzv2si2 },
  { 0x58003c, CODE_FOR_clzv16qi2 },
  { 0x58003d, CODE_FOR_clzv8hi2 },
  { 0x58003e, CODE_FOR_clzv4si2 },
  { 0x59000e, CODE_FOR_ctzsi2 },
  { 0x59000f, CODE_FOR_ctzdi2 },
  { 0x59003b, CODE_FOR_ctzv2si2 },
  { 0x59003e, CODE_FOR_ctzv4si2 },
  { 0x5a000e, CODE_FOR_clrsbsi2 },
  { 0x5a000f, CODE_FOR_clrsbdi2 },
  { 0x5a0039, CODE_FOR_clrsbv8qi2 },
  { 0x5a003a, CODE_FOR_clrsbv4hi2 },
  { 0x5a003b, CODE_FOR_clrsbv2si2 },
  { 0x5a003c, CODE_FOR_clrsbv16qi2 },
  { 0x5a003d, CODE_FOR_clrsbv8hi2 },
  { 0x5a003e, CODE_FOR_clrsbv4si2 },
  { 0x5b0039, CODE_FOR_popcountv8qi2 },
  { 0x5b003c, CODE_FOR_popcountv16qi2 },
  { 0x670027, CODE_FOR_sqrtsf2 },
  { 0x670028, CODE_FOR_sqrtdf2 },
  { 0x670051, CODE_FOR_sqrtv2sf2 },
  { 0x670054, CODE_FOR_sqrtv4sf2 },
  { 0x670055, CODE_FOR_sqrtv2df2 },
  { 0x76000c, CODE_FOR_movqi },
  { 0x76000d, CODE_FOR_movhi },
  { 0x76000e, CODE_FOR_movsi },
  { 0x76000f, CODE_FOR_movdi },
  { 0x760010, CODE_FOR_movti },
  { 0x760011, CODE_FOR_movoi },
  { 0x760012, CODE_FOR_movci },
  { 0x760013, CODE_FOR_movxi },
  { 0x760026, CODE_FOR_movhf },
  { 0x760027, CODE_FOR_movsf },
  { 0x760028, CODE_FOR_movdf },
  { 0x760029, CODE_FOR_movtf },
  { 0x760039, CODE_FOR_movv8qi },
  { 0x76003a, CODE_FOR_movv4hi },
  { 0x76003b, CODE_FOR_movv2si },
  { 0x76003c, CODE_FOR_movv16qi },
  { 0x76003d, CODE_FOR_movv8hi },
  { 0x76003e, CODE_FOR_movv4si },
  { 0x76003f, CODE_FOR_movv2di },
  { 0x760050, CODE_FOR_movv4hf },
  { 0x760051, CODE_FOR_movv2sf },
  { 0x760053, CODE_FOR_movv8hf },
  { 0x760054, CODE_FOR_movv4sf },
  { 0x760055, CODE_FOR_movv2df },
  { 0x780039, CODE_FOR_movmisalignv8qi },
  { 0x78003a, CODE_FOR_movmisalignv4hi },
  { 0x78003b, CODE_FOR_movmisalignv2si },
  { 0x78003c, CODE_FOR_movmisalignv16qi },
  { 0x78003d, CODE_FOR_movmisalignv8hi },
  { 0x78003e, CODE_FOR_movmisalignv4si },
  { 0x78003f, CODE_FOR_movmisalignv2di },
  { 0x780051, CODE_FOR_movmisalignv2sf },
  { 0x780054, CODE_FOR_movmisalignv4sf },
  { 0x780055, CODE_FOR_movmisalignv2df },
  { 0x7a000e, CODE_FOR_insvsi },
  { 0x7a000f, CODE_FOR_insvdi },
  { 0x830002, CODE_FOR_cbranchcc4 },
  { 0x83000e, CODE_FOR_cbranchsi4 },
  { 0x83000f, CODE_FOR_cbranchdi4 },
  { 0x830027, CODE_FOR_cbranchsf4 },
  { 0x830028, CODE_FOR_cbranchdf4 },
  { 0x85000e, CODE_FOR_negsicc },
  { 0x85000f, CODE_FOR_negdicc },
  { 0x86000e, CODE_FOR_notsicc },
  { 0x86000f, CODE_FOR_notdicc },
  { 0x87000c, CODE_FOR_movqicc },
  { 0x87000d, CODE_FOR_movhicc },
  { 0x87000e, CODE_FOR_movsicc },
  { 0x87000f, CODE_FOR_movdicc },
  { 0x870027, CODE_FOR_movsfcc },
  { 0x870028, CODE_FOR_movdfcc },
  { 0x88000e, CODE_FOR_cmovsi6 },
  { 0x88000f, CODE_FOR_cmovdi6 },
  { 0x880027, CODE_FOR_cmovsf6 },
  { 0x880028, CODE_FOR_cmovdf6 },
  { 0x890002, CODE_FOR_cstorecc4 },
  { 0x89000e, CODE_FOR_cstoresi4 },
  { 0x89000f, CODE_FOR_cstoredi4 },
  { 0x890027, CODE_FOR_cstoresf4 },
  { 0x890028, CODE_FOR_cstoredf4 },
  { 0x93000f, CODE_FOR_smuldi3_highpart },
  { 0x94000f, CODE_FOR_umuldi3_highpart },
  { 0x98000f, CODE_FOR_movmemdi },
  { 0x9b0027, CODE_FOR_fmasf4 },
  { 0x9b0028, CODE_FOR_fmadf4 },
  { 0x9b0051, CODE_FOR_fmav2sf4 },
  { 0x9b0054, CODE_FOR_fmav4sf4 },
  { 0x9b0055, CODE_FOR_fmav2df4 },
  { 0x9c0027, CODE_FOR_fmssf4 },
  { 0x9c0028, CODE_FOR_fmsdf4 },
  { 0x9d0027, CODE_FOR_fnmasf4 },
  { 0x9d0028, CODE_FOR_fnmadf4 },
  { 0x9d0051, CODE_FOR_fnmav2sf4 },
  { 0x9d0054, CODE_FOR_fnmav4sf4 },
  { 0x9d0055, CODE_FOR_fnmav2df4 },
  { 0x9e0027, CODE_FOR_fnmssf4 },
  { 0x9e0028, CODE_FOR_fnmsdf4 },
  { 0x9f0027, CODE_FOR_rintsf2 },
  { 0x9f0028, CODE_FOR_rintdf2 },
  { 0x9f0051, CODE_FOR_rintv2sf2 },
  { 0x9f0054, CODE_FOR_rintv4sf2 },
  { 0x9f0055, CODE_FOR_rintv2df2 },
  { 0xa00027, CODE_FOR_roundsf2 },
  { 0xa00028, CODE_FOR_rounddf2 },
  { 0xa00051, CODE_FOR_roundv2sf2 },
  { 0xa00054, CODE_FOR_roundv4sf2 },
  { 0xa00055, CODE_FOR_roundv2df2 },
  { 0xa10027, CODE_FOR_floorsf2 },
  { 0xa10028, CODE_FOR_floordf2 },
  { 0xa10051, CODE_FOR_floorv2sf2 },
  { 0xa10054, CODE_FOR_floorv4sf2 },
  { 0xa10055, CODE_FOR_floorv2df2 },
  { 0xa20027, CODE_FOR_ceilsf2 },
  { 0xa20028, CODE_FOR_ceildf2 },
  { 0xa20051, CODE_FOR_ceilv2sf2 },
  { 0xa20054, CODE_FOR_ceilv4sf2 },
  { 0xa20055, CODE_FOR_ceilv2df2 },
  { 0xa30027, CODE_FOR_btruncsf2 },
  { 0xa30028, CODE_FOR_btruncdf2 },
  { 0xa30051, CODE_FOR_btruncv2sf2 },
  { 0xa30054, CODE_FOR_btruncv4sf2 },
  { 0xa30055, CODE_FOR_btruncv2df2 },
  { 0xa40027, CODE_FOR_nearbyintsf2 },
  { 0xa40028, CODE_FOR_nearbyintdf2 },
  { 0xa40051, CODE_FOR_nearbyintv2sf2 },
  { 0xa40054, CODE_FOR_nearbyintv4sf2 },
  { 0xa40055, CODE_FOR_nearbyintv2df2 },
  { 0xa90027, CODE_FOR_copysignsf3 },
  { 0xa90028, CODE_FOR_copysigndf3 },
  { 0xba0027, CODE_FOR_rsqrtsf2 },
  { 0xba0028, CODE_FOR_rsqrtdf2 },
  { 0xba0051, CODE_FOR_rsqrtv2sf2 },
  { 0xba0054, CODE_FOR_rsqrtv4sf2 },
  { 0xba0055, CODE_FOR_rsqrtv2df2 },
  { 0xc10027, CODE_FOR_fmaxsf3 },
  { 0xc10028, CODE_FOR_fmaxdf3 },
  { 0xc10051, CODE_FOR_fmaxv2sf3 },
  { 0xc10054, CODE_FOR_fmaxv4sf3 },
  { 0xc10055, CODE_FOR_fmaxv2df3 },
  { 0xc20027, CODE_FOR_fminsf3 },
  { 0xc20028, CODE_FOR_fmindf3 },
  { 0xc20051, CODE_FOR_fminv2sf3 },
  { 0xc20054, CODE_FOR_fminv4sf3 },
  { 0xc20055, CODE_FOR_fminv2df3 },
  { 0xc30039, CODE_FOR_reduc_smax_scal_v8qi },
  { 0xc3003a, CODE_FOR_reduc_smax_scal_v4hi },
  { 0xc3003b, CODE_FOR_reduc_smax_scal_v2si },
  { 0xc3003c, CODE_FOR_reduc_smax_scal_v16qi },
  { 0xc3003d, CODE_FOR_reduc_smax_scal_v8hi },
  { 0xc3003e, CODE_FOR_reduc_smax_scal_v4si },
  { 0xc30051, CODE_FOR_reduc_smax_scal_v2sf },
  { 0xc30054, CODE_FOR_reduc_smax_scal_v4sf },
  { 0xc30055, CODE_FOR_reduc_smax_scal_v2df },
  { 0xc40039, CODE_FOR_reduc_smin_scal_v8qi },
  { 0xc4003a, CODE_FOR_reduc_smin_scal_v4hi },
  { 0xc4003b, CODE_FOR_reduc_smin_scal_v2si },
  { 0xc4003c, CODE_FOR_reduc_smin_scal_v16qi },
  { 0xc4003d, CODE_FOR_reduc_smin_scal_v8hi },
  { 0xc4003e, CODE_FOR_reduc_smin_scal_v4si },
  { 0xc40051, CODE_FOR_reduc_smin_scal_v2sf },
  { 0xc40054, CODE_FOR_reduc_smin_scal_v4sf },
  { 0xc40055, CODE_FOR_reduc_smin_scal_v2df },
  { 0xc50039, CODE_FOR_reduc_plus_scal_v8qi },
  { 0xc5003a, CODE_FOR_reduc_plus_scal_v4hi },
  { 0xc5003b, CODE_FOR_reduc_plus_scal_v2si },
  { 0xc5003c, CODE_FOR_reduc_plus_scal_v16qi },
  { 0xc5003d, CODE_FOR_reduc_plus_scal_v8hi },
  { 0xc5003e, CODE_FOR_reduc_plus_scal_v4si },
  { 0xc5003f, CODE_FOR_reduc_plus_scal_v2di },
  { 0xc50051, CODE_FOR_reduc_plus_scal_v2sf },
  { 0xc50054, CODE_FOR_reduc_plus_scal_v4sf },
  { 0xc50055, CODE_FOR_reduc_plus_scal_v2df },
  { 0xc60039, CODE_FOR_reduc_umax_scal_v8qi },
  { 0xc6003a, CODE_FOR_reduc_umax_scal_v4hi },
  { 0xc6003b, CODE_FOR_reduc_umax_scal_v2si },
  { 0xc6003c, CODE_FOR_reduc_umax_scal_v16qi },
  { 0xc6003d, CODE_FOR_reduc_umax_scal_v8hi },
  { 0xc6003e, CODE_FOR_reduc_umax_scal_v4si },
  { 0xc70039, CODE_FOR_reduc_umin_scal_v8qi },
  { 0xc7003a, CODE_FOR_reduc_umin_scal_v4hi },
  { 0xc7003b, CODE_FOR_reduc_umin_scal_v2si },
  { 0xc7003c, CODE_FOR_reduc_umin_scal_v16qi },
  { 0xc7003d, CODE_FOR_reduc_umin_scal_v8hi },
  { 0xc7003e, CODE_FOR_reduc_umin_scal_v4si },
  { 0xc90039, CODE_FOR_widen_ssumv8qi3 },
  { 0xc9003a, CODE_FOR_widen_ssumv4hi3 },
  { 0xc9003b, CODE_FOR_widen_ssumv2si3 },
  { 0xc9003c, CODE_FOR_widen_ssumv16qi3 },
  { 0xc9003d, CODE_FOR_widen_ssumv8hi3 },
  { 0xc9003e, CODE_FOR_widen_ssumv4si3 },
  { 0xcb0039, CODE_FOR_widen_usumv8qi3 },
  { 0xcb003a, CODE_FOR_widen_usumv4hi3 },
  { 0xcb003b, CODE_FOR_widen_usumv2si3 },
  { 0xcb003c, CODE_FOR_widen_usumv16qi3 },
  { 0xcb003d, CODE_FOR_widen_usumv8hi3 },
  { 0xcb003e, CODE_FOR_widen_usumv4si3 },
  { 0xce0039, CODE_FOR_vec_extractv8qi },
  { 0xce003a, CODE_FOR_vec_extractv4hi },
  { 0xce003b, CODE_FOR_vec_extractv2si },
  { 0xce003c, CODE_FOR_vec_extractv16qi },
  { 0xce003d, CODE_FOR_vec_extractv8hi },
  { 0xce003e, CODE_FOR_vec_extractv4si },
  { 0xce003f, CODE_FOR_vec_extractv2di },
  { 0xce0050, CODE_FOR_vec_extractv4hf },
  { 0xce0051, CODE_FOR_vec_extractv2sf },
  { 0xce0053, CODE_FOR_vec_extractv8hf },
  { 0xce0054, CODE_FOR_vec_extractv4sf },
  { 0xce0055, CODE_FOR_vec_extractv2df },
  { 0xcf0039, CODE_FOR_vec_initv8qi },
  { 0xcf003a, CODE_FOR_vec_initv4hi },
  { 0xcf003b, CODE_FOR_vec_initv2si },
  { 0xcf003c, CODE_FOR_vec_initv16qi },
  { 0xcf003d, CODE_FOR_vec_initv8hi },
  { 0xcf003e, CODE_FOR_vec_initv4si },
  { 0xcf003f, CODE_FOR_vec_initv2di },
  { 0xcf0050, CODE_FOR_vec_initv4hf },
  { 0xcf0051, CODE_FOR_vec_initv2sf },
  { 0xcf0053, CODE_FOR_vec_initv8hf },
  { 0xcf0054, CODE_FOR_vec_initv4sf },
  { 0xcf0055, CODE_FOR_vec_initv2df },
  { 0xd2000f, CODE_FOR_vec_pack_trunc_di },
  { 0xd20028, CODE_FOR_vec_pack_trunc_df },
  { 0xd2003a, CODE_FOR_vec_pack_trunc_v4hi },
  { 0xd2003b, CODE_FOR_vec_pack_trunc_v2si },
  { 0xd2003d, CODE_FOR_vec_pack_trunc_v8hi },
  { 0xd2003e, CODE_FOR_vec_pack_trunc_v4si },
  { 0xd2003f, CODE_FOR_vec_pack_trunc_v2di },
  { 0xd20055, CODE_FOR_vec_pack_trunc_v2df },
  { 0xd50039, CODE_FOR_vec_perm_constv8qi },
  { 0xd5003a, CODE_FOR_vec_perm_constv4hi },
  { 0xd5003b, CODE_FOR_vec_perm_constv2si },
  { 0xd5003c, CODE_FOR_vec_perm_constv16qi },
  { 0xd5003d, CODE_FOR_vec_perm_constv8hi },
  { 0xd5003e, CODE_FOR_vec_perm_constv4si },
  { 0xd5003f, CODE_FOR_vec_perm_constv2di },
  { 0xd50050, CODE_FOR_vec_perm_constv4hf },
  { 0xd50051, CODE_FOR_vec_perm_constv2sf },
  { 0xd50053, CODE_FOR_vec_perm_constv8hf },
  { 0xd50054, CODE_FOR_vec_perm_constv4sf },
  { 0xd50055, CODE_FOR_vec_perm_constv2df },
  { 0xd60039, CODE_FOR_vec_permv8qi },
  { 0xd6003c, CODE_FOR_vec_permv16qi },
  { 0xd80039, CODE_FOR_vec_setv8qi },
  { 0xd8003a, CODE_FOR_vec_setv4hi },
  { 0xd8003b, CODE_FOR_vec_setv2si },
  { 0xd8003c, CODE_FOR_vec_setv16qi },
  { 0xd8003d, CODE_FOR_vec_setv8hi },
  { 0xd8003e, CODE_FOR_vec_setv4si },
  { 0xd8003f, CODE_FOR_vec_setv2di },
  { 0xd80050, CODE_FOR_vec_setv4hf },
  { 0xd80051, CODE_FOR_vec_setv2sf },
  { 0xd80053, CODE_FOR_vec_setv8hf },
  { 0xd80054, CODE_FOR_vec_setv4sf },
  { 0xd80055, CODE_FOR_vec_setv2df },
  { 0xd90039, CODE_FOR_vec_shr_v8qi },
  { 0xd9003a, CODE_FOR_vec_shr_v4hi },
  { 0xd9003b, CODE_FOR_vec_shr_v2si },
  { 0xd90050, CODE_FOR_vec_shr_v4hf },
  { 0xd90051, CODE_FOR_vec_shr_v2sf },
  { 0xdc003c, CODE_FOR_vec_unpacks_hi_v16qi },
  { 0xdc003d, CODE_FOR_vec_unpacks_hi_v8hi },
  { 0xdc003e, CODE_FOR_vec_unpacks_hi_v4si },
  { 0xdc0053, CODE_FOR_vec_unpacks_hi_v8hf },
  { 0xdc0054, CODE_FOR_vec_unpacks_hi_v4sf },
  { 0xdd003c, CODE_FOR_vec_unpacks_lo_v16qi },
  { 0xdd003d, CODE_FOR_vec_unpacks_lo_v8hi },
  { 0xdd003e, CODE_FOR_vec_unpacks_lo_v4si },
  { 0xdd0053, CODE_FOR_vec_unpacks_lo_v8hf },
  { 0xdd0054, CODE_FOR_vec_unpacks_lo_v4sf },
  { 0xe0003c, CODE_FOR_vec_unpacku_hi_v16qi },
  { 0xe0003d, CODE_FOR_vec_unpacku_hi_v8hi },
  { 0xe0003e, CODE_FOR_vec_unpacku_hi_v4si },
  { 0xe1003c, CODE_FOR_vec_unpacku_lo_v16qi },
  { 0xe1003d, CODE_FOR_vec_unpacku_lo_v8hi },
  { 0xe1003e, CODE_FOR_vec_unpacku_lo_v4si },
  { 0xe3003c, CODE_FOR_vec_widen_smult_hi_v16qi },
  { 0xe3003d, CODE_FOR_vec_widen_smult_hi_v8hi },
  { 0xe3003e, CODE_FOR_vec_widen_smult_hi_v4si },
  { 0xe4003c, CODE_FOR_vec_widen_smult_lo_v16qi },
  { 0xe4003d, CODE_FOR_vec_widen_smult_lo_v8hi },
  { 0xe4003e, CODE_FOR_vec_widen_smult_lo_v4si },
  { 0xe9003c, CODE_FOR_vec_widen_umult_hi_v16qi },
  { 0xe9003d, CODE_FOR_vec_widen_umult_hi_v8hi },
  { 0xe9003e, CODE_FOR_vec_widen_umult_hi_v4si },
  { 0xea003c, CODE_FOR_vec_widen_umult_lo_v16qi },
  { 0xea003d, CODE_FOR_vec_widen_umult_lo_v8hi },
  { 0xea003e, CODE_FOR_vec_widen_umult_lo_v4si },
  { 0xf5000c, CODE_FOR_atomic_add_fetchqi },
  { 0xf5000d, CODE_FOR_atomic_add_fetchhi },
  { 0xf5000e, CODE_FOR_atomic_add_fetchsi },
  { 0xf5000f, CODE_FOR_atomic_add_fetchdi },
  { 0xf6000c, CODE_FOR_atomic_addqi },
  { 0xf6000d, CODE_FOR_atomic_addhi },
  { 0xf6000e, CODE_FOR_atomic_addsi },
  { 0xf6000f, CODE_FOR_atomic_adddi },
  { 0xf7000c, CODE_FOR_atomic_and_fetchqi },
  { 0xf7000d, CODE_FOR_atomic_and_fetchhi },
  { 0xf7000e, CODE_FOR_atomic_and_fetchsi },
  { 0xf7000f, CODE_FOR_atomic_and_fetchdi },
  { 0xf8000c, CODE_FOR_atomic_andqi },
  { 0xf8000d, CODE_FOR_atomic_andhi },
  { 0xf8000e, CODE_FOR_atomic_andsi },
  { 0xf8000f, CODE_FOR_atomic_anddi },
  { 0xf9000c, CODE_FOR_atomic_compare_and_swapqi },
  { 0xf9000d, CODE_FOR_atomic_compare_and_swaphi },
  { 0xf9000e, CODE_FOR_atomic_compare_and_swapsi },
  { 0xf9000f, CODE_FOR_atomic_compare_and_swapdi },
  { 0xfa000c, CODE_FOR_atomic_exchangeqi },
  { 0xfa000d, CODE_FOR_atomic_exchangehi },
  { 0xfa000e, CODE_FOR_atomic_exchangesi },
  { 0xfa000f, CODE_FOR_atomic_exchangedi },
  { 0xfb000c, CODE_FOR_atomic_fetch_addqi },
  { 0xfb000d, CODE_FOR_atomic_fetch_addhi },
  { 0xfb000e, CODE_FOR_atomic_fetch_addsi },
  { 0xfb000f, CODE_FOR_atomic_fetch_adddi },
  { 0xfc000c, CODE_FOR_atomic_fetch_andqi },
  { 0xfc000d, CODE_FOR_atomic_fetch_andhi },
  { 0xfc000e, CODE_FOR_atomic_fetch_andsi },
  { 0xfc000f, CODE_FOR_atomic_fetch_anddi },
  { 0xfd000c, CODE_FOR_atomic_fetch_nandqi },
  { 0xfd000d, CODE_FOR_atomic_fetch_nandhi },
  { 0xfd000e, CODE_FOR_atomic_fetch_nandsi },
  { 0xfd000f, CODE_FOR_atomic_fetch_nanddi },
  { 0xfe000c, CODE_FOR_atomic_fetch_orqi },
  { 0xfe000d, CODE_FOR_atomic_fetch_orhi },
  { 0xfe000e, CODE_FOR_atomic_fetch_orsi },
  { 0xfe000f, CODE_FOR_atomic_fetch_ordi },
  { 0xff000c, CODE_FOR_atomic_fetch_subqi },
  { 0xff000d, CODE_FOR_atomic_fetch_subhi },
  { 0xff000e, CODE_FOR_atomic_fetch_subsi },
  { 0xff000f, CODE_FOR_atomic_fetch_subdi },
  { 0x100000c, CODE_FOR_atomic_fetch_xorqi },
  { 0x100000d, CODE_FOR_atomic_fetch_xorhi },
  { 0x100000e, CODE_FOR_atomic_fetch_xorsi },
  { 0x100000f, CODE_FOR_atomic_fetch_xordi },
  { 0x101000c, CODE_FOR_atomic_loadqi },
  { 0x101000d, CODE_FOR_atomic_loadhi },
  { 0x101000e, CODE_FOR_atomic_loadsi },
  { 0x101000f, CODE_FOR_atomic_loaddi },
  { 0x102000c, CODE_FOR_atomic_nand_fetchqi },
  { 0x102000d, CODE_FOR_atomic_nand_fetchhi },
  { 0x102000e, CODE_FOR_atomic_nand_fetchsi },
  { 0x102000f, CODE_FOR_atomic_nand_fetchdi },
  { 0x103000c, CODE_FOR_atomic_nandqi },
  { 0x103000d, CODE_FOR_atomic_nandhi },
  { 0x103000e, CODE_FOR_atomic_nandsi },
  { 0x103000f, CODE_FOR_atomic_nanddi },
  { 0x104000c, CODE_FOR_atomic_or_fetchqi },
  { 0x104000d, CODE_FOR_atomic_or_fetchhi },
  { 0x104000e, CODE_FOR_atomic_or_fetchsi },
  { 0x104000f, CODE_FOR_atomic_or_fetchdi },
  { 0x105000c, CODE_FOR_atomic_orqi },
  { 0x105000d, CODE_FOR_atomic_orhi },
  { 0x105000e, CODE_FOR_atomic_orsi },
  { 0x105000f, CODE_FOR_atomic_ordi },
  { 0x106000c, CODE_FOR_atomic_storeqi },
  { 0x106000d, CODE_FOR_atomic_storehi },
  { 0x106000e, CODE_FOR_atomic_storesi },
  { 0x106000f, CODE_FOR_atomic_storedi },
  { 0x107000c, CODE_FOR_atomic_sub_fetchqi },
  { 0x107000d, CODE_FOR_atomic_sub_fetchhi },
  { 0x107000e, CODE_FOR_atomic_sub_fetchsi },
  { 0x107000f, CODE_FOR_atomic_sub_fetchdi },
  { 0x108000c, CODE_FOR_atomic_subqi },
  { 0x108000d, CODE_FOR_atomic_subhi },
  { 0x108000e, CODE_FOR_atomic_subsi },
  { 0x108000f, CODE_FOR_atomic_subdi },
  { 0x109000c, CODE_FOR_atomic_xor_fetchqi },
  { 0x109000d, CODE_FOR_atomic_xor_fetchhi },
  { 0x109000e, CODE_FOR_atomic_xor_fetchsi },
  { 0x109000f, CODE_FOR_atomic_xor_fetchdi },
  { 0x10a000c, CODE_FOR_atomic_xorqi },
  { 0x10a000d, CODE_FOR_atomic_xorhi },
  { 0x10a000e, CODE_FOR_atomic_xorsi },
  { 0x10a000f, CODE_FOR_atomic_xordi },
  { 0x10b000f, CODE_FOR_get_thread_pointerdi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqihi2;
  ena[1] = HAVE_extendqisi2;
  ena[2] = HAVE_extendqidi2;
  ena[3] = HAVE_extendhisi2;
  ena[4] = HAVE_extendhidi2;
  ena[5] = HAVE_extendsidi2;
  ena[6] = HAVE_extendhfsf2;
  ena[7] = HAVE_extendhfdf2;
  ena[8] = HAVE_extendsfdf2;
  ena[9] = HAVE_truncsfhf2;
  ena[10] = HAVE_truncdfhf2;
  ena[11] = HAVE_truncdfsf2;
  ena[12] = HAVE_zero_extendqihi2;
  ena[13] = HAVE_zero_extendqisi2;
  ena[14] = HAVE_zero_extendqidi2;
  ena[15] = HAVE_zero_extendhisi2;
  ena[16] = HAVE_zero_extendhidi2;
  ena[17] = HAVE_zero_extendsidi2;
  ena[18] = HAVE_fixv2sfv2si2;
  ena[19] = HAVE_fixv4sfv4si2;
  ena[20] = HAVE_fixv2dfv2di2;
  ena[21] = HAVE_fixunsv2sfv2si2;
  ena[22] = HAVE_fixunsv4sfv4si2;
  ena[23] = HAVE_fixunsv2dfv2di2;
  ena[24] = HAVE_floatsisf2;
  ena[25] = HAVE_floatsidf2;
  ena[26] = HAVE_floatdisf2;
  ena[27] = HAVE_floatdidf2;
  ena[28] = HAVE_floatv2siv2sf2;
  ena[29] = HAVE_floatv4siv4sf2;
  ena[30] = HAVE_floatv2div2df2;
  ena[31] = HAVE_floatunssisf2;
  ena[32] = HAVE_floatunssidf2;
  ena[33] = HAVE_floatunsdisf2;
  ena[34] = HAVE_floatunsdidf2;
  ena[35] = HAVE_floatunsv2siv2sf2;
  ena[36] = HAVE_floatunsv4siv4sf2;
  ena[37] = HAVE_floatunsv2div2df2;
  ena[38] = HAVE_lroundsfsi2;
  ena[39] = HAVE_lroundsfdi2;
  ena[40] = HAVE_lrounddfsi2;
  ena[41] = HAVE_lrounddfdi2;
  ena[42] = HAVE_lroundv2sfv2si2;
  ena[43] = HAVE_lroundv4sfv4si2;
  ena[44] = HAVE_lroundv2dfv2di2;
  ena[45] = HAVE_lfloorsfsi2;
  ena[46] = HAVE_lfloorsfdi2;
  ena[47] = HAVE_lfloordfsi2;
  ena[48] = HAVE_lfloordfdi2;
  ena[49] = HAVE_lfloorv2sfv2si2;
  ena[50] = HAVE_lfloorv4sfv4si2;
  ena[51] = HAVE_lfloorv2dfv2di2;
  ena[52] = HAVE_lceilsfsi2;
  ena[53] = HAVE_lceilsfdi2;
  ena[54] = HAVE_lceildfsi2;
  ena[55] = HAVE_lceildfdi2;
  ena[56] = HAVE_lceilv2sfv2si2;
  ena[57] = HAVE_lceilv4sfv4si2;
  ena[58] = HAVE_lceilv2dfv2di2;
  ena[59] = HAVE_fix_truncsfsi2;
  ena[60] = HAVE_fix_truncsfdi2;
  ena[61] = HAVE_fix_truncdfsi2;
  ena[62] = HAVE_fix_truncdfdi2;
  ena[63] = HAVE_fix_truncv2sfv2si2;
  ena[64] = HAVE_fix_truncv4sfv4si2;
  ena[65] = HAVE_fix_truncv2dfv2di2;
  ena[66] = HAVE_fixuns_truncsfsi2;
  ena[67] = HAVE_fixuns_truncsfdi2;
  ena[68] = HAVE_fixuns_truncdfsi2;
  ena[69] = HAVE_fixuns_truncdfdi2;
  ena[70] = HAVE_fixuns_truncv2sfv2si2;
  ena[71] = HAVE_fixuns_truncv4sfv4si2;
  ena[72] = HAVE_fixuns_truncv2dfv2di2;
  ena[73] = HAVE_mulsidi3;
  ena[74] = HAVE_mulditi3;
  ena[75] = HAVE_umulsidi3;
  ena[76] = HAVE_umulditi3;
  ena[77] = HAVE_maddsidi4;
  ena[78] = HAVE_umaddsidi4;
  ena[79] = HAVE_msubsidi4;
  ena[80] = HAVE_umsubsidi4;
  ena[81] = HAVE_vec_load_lanesoiv16qi;
  ena[82] = HAVE_vec_load_lanesciv16qi;
  ena[83] = HAVE_vec_load_lanesxiv16qi;
  ena[84] = HAVE_vec_load_lanesoiv8hi;
  ena[85] = HAVE_vec_load_lanesciv8hi;
  ena[86] = HAVE_vec_load_lanesxiv8hi;
  ena[87] = HAVE_vec_load_lanesoiv4si;
  ena[88] = HAVE_vec_load_lanesciv4si;
  ena[89] = HAVE_vec_load_lanesxiv4si;
  ena[90] = HAVE_vec_load_lanesoiv2di;
  ena[91] = HAVE_vec_load_lanesciv2di;
  ena[92] = HAVE_vec_load_lanesxiv2di;
  ena[93] = HAVE_vec_load_lanesoiv8hf;
  ena[94] = HAVE_vec_load_lanesciv8hf;
  ena[95] = HAVE_vec_load_lanesxiv8hf;
  ena[96] = HAVE_vec_load_lanesoiv4sf;
  ena[97] = HAVE_vec_load_lanesciv4sf;
  ena[98] = HAVE_vec_load_lanesxiv4sf;
  ena[99] = HAVE_vec_load_lanesoiv2df;
  ena[100] = HAVE_vec_load_lanesciv2df;
  ena[101] = HAVE_vec_load_lanesxiv2df;
  ena[102] = HAVE_vec_store_lanesoiv16qi;
  ena[103] = HAVE_vec_store_lanesciv16qi;
  ena[104] = HAVE_vec_store_lanesxiv16qi;
  ena[105] = HAVE_vec_store_lanesoiv8hi;
  ena[106] = HAVE_vec_store_lanesciv8hi;
  ena[107] = HAVE_vec_store_lanesxiv8hi;
  ena[108] = HAVE_vec_store_lanesoiv4si;
  ena[109] = HAVE_vec_store_lanesciv4si;
  ena[110] = HAVE_vec_store_lanesxiv4si;
  ena[111] = HAVE_vec_store_lanesoiv2di;
  ena[112] = HAVE_vec_store_lanesciv2di;
  ena[113] = HAVE_vec_store_lanesxiv2di;
  ena[114] = HAVE_vec_store_lanesoiv8hf;
  ena[115] = HAVE_vec_store_lanesciv8hf;
  ena[116] = HAVE_vec_store_lanesxiv8hf;
  ena[117] = HAVE_vec_store_lanesoiv4sf;
  ena[118] = HAVE_vec_store_lanesciv4sf;
  ena[119] = HAVE_vec_store_lanesxiv4sf;
  ena[120] = HAVE_vec_store_lanesoiv2df;
  ena[121] = HAVE_vec_store_lanesciv2df;
  ena[122] = HAVE_vec_store_lanesxiv2df;
  ena[123] = HAVE_vconddidi;
  ena[124] = HAVE_vcondv8qiv8qi;
  ena[125] = HAVE_vcondv4hiv4hi;
  ena[126] = HAVE_vcondv2siv2si;
  ena[127] = HAVE_vcondv16qiv16qi;
  ena[128] = HAVE_vcondv8hiv8hi;
  ena[129] = HAVE_vcondv4siv4si;
  ena[130] = HAVE_vcondv2div2di;
  ena[131] = HAVE_vcondv2siv2sf;
  ena[132] = HAVE_vcondv2sfv2sf;
  ena[133] = HAVE_vcondv4siv4sf;
  ena[134] = HAVE_vcondv4sfv4sf;
  ena[135] = HAVE_vcondv2div2df;
  ena[136] = HAVE_vcondv2dfv2df;
  ena[137] = HAVE_vcondudidi;
  ena[138] = HAVE_vconduv8qiv8qi;
  ena[139] = HAVE_vconduv4hiv4hi;
  ena[140] = HAVE_vconduv2siv2si;
  ena[141] = HAVE_vconduv16qiv16qi;
  ena[142] = HAVE_vconduv8hiv8hi;
  ena[143] = HAVE_vconduv4siv4si;
  ena[144] = HAVE_vconduv2div2di;
  ena[145] = HAVE_addsi3;
  ena[146] = HAVE_adddi3;
  ena[147] = HAVE_addti3;
  ena[148] = HAVE_addsf3;
  ena[149] = HAVE_adddf3;
  ena[150] = HAVE_addv8qi3;
  ena[151] = HAVE_addv4hi3;
  ena[152] = HAVE_addv2si3;
  ena[153] = HAVE_addv16qi3;
  ena[154] = HAVE_addv8hi3;
  ena[155] = HAVE_addv4si3;
  ena[156] = HAVE_addv2di3;
  ena[157] = HAVE_addv2sf3;
  ena[158] = HAVE_addv4sf3;
  ena[159] = HAVE_addv2df3;
  ena[160] = HAVE_subsi3;
  ena[161] = HAVE_subdi3;
  ena[162] = HAVE_subti3;
  ena[163] = HAVE_subsf3;
  ena[164] = HAVE_subdf3;
  ena[165] = HAVE_subv8qi3;
  ena[166] = HAVE_subv4hi3;
  ena[167] = HAVE_subv2si3;
  ena[168] = HAVE_subv16qi3;
  ena[169] = HAVE_subv8hi3;
  ena[170] = HAVE_subv4si3;
  ena[171] = HAVE_subv2di3;
  ena[172] = HAVE_subv2sf3;
  ena[173] = HAVE_subv4sf3;
  ena[174] = HAVE_subv2df3;
  ena[175] = HAVE_mulsi3;
  ena[176] = HAVE_muldi3;
  ena[177] = HAVE_multi3;
  ena[178] = HAVE_mulsf3;
  ena[179] = HAVE_muldf3;
  ena[180] = HAVE_mulv8qi3;
  ena[181] = HAVE_mulv4hi3;
  ena[182] = HAVE_mulv2si3;
  ena[183] = HAVE_mulv16qi3;
  ena[184] = HAVE_mulv8hi3;
  ena[185] = HAVE_mulv4si3;
  ena[186] = HAVE_mulv2sf3;
  ena[187] = HAVE_mulv4sf3;
  ena[188] = HAVE_mulv2df3;
  ena[189] = HAVE_divsi3;
  ena[190] = HAVE_divdi3;
  ena[191] = HAVE_divsf3;
  ena[192] = HAVE_divdf3;
  ena[193] = HAVE_divv2sf3;
  ena[194] = HAVE_divv4sf3;
  ena[195] = HAVE_divv2df3;
  ena[196] = HAVE_udivsi3;
  ena[197] = HAVE_udivdi3;
  ena[198] = HAVE_modsi3;
  ena[199] = HAVE_moddi3;
  ena[200] = HAVE_ftruncv2sf2;
  ena[201] = HAVE_ftruncv4sf2;
  ena[202] = HAVE_ftruncv2df2;
  ena[203] = HAVE_andsi3;
  ena[204] = HAVE_anddi3;
  ena[205] = HAVE_andv8qi3;
  ena[206] = HAVE_andv4hi3;
  ena[207] = HAVE_andv2si3;
  ena[208] = HAVE_andv16qi3;
  ena[209] = HAVE_andv8hi3;
  ena[210] = HAVE_andv4si3;
  ena[211] = HAVE_andv2di3;
  ena[212] = HAVE_iorsi3;
  ena[213] = HAVE_iordi3;
  ena[214] = HAVE_iorv8qi3;
  ena[215] = HAVE_iorv4hi3;
  ena[216] = HAVE_iorv2si3;
  ena[217] = HAVE_iorv16qi3;
  ena[218] = HAVE_iorv8hi3;
  ena[219] = HAVE_iorv4si3;
  ena[220] = HAVE_iorv2di3;
  ena[221] = HAVE_xorsi3;
  ena[222] = HAVE_xordi3;
  ena[223] = HAVE_xorv8qi3;
  ena[224] = HAVE_xorv4hi3;
  ena[225] = HAVE_xorv2si3;
  ena[226] = HAVE_xorv16qi3;
  ena[227] = HAVE_xorv8hi3;
  ena[228] = HAVE_xorv4si3;
  ena[229] = HAVE_xorv2di3;
  ena[230] = HAVE_ashlqi3;
  ena[231] = HAVE_ashlhi3;
  ena[232] = HAVE_ashlsi3;
  ena[233] = HAVE_ashldi3;
  ena[234] = HAVE_ashlv8qi3;
  ena[235] = HAVE_ashlv4hi3;
  ena[236] = HAVE_ashlv2si3;
  ena[237] = HAVE_ashlv16qi3;
  ena[238] = HAVE_ashlv8hi3;
  ena[239] = HAVE_ashlv4si3;
  ena[240] = HAVE_ashlv2di3;
  ena[241] = HAVE_ashrsi3;
  ena[242] = HAVE_ashrdi3;
  ena[243] = HAVE_ashrv8qi3;
  ena[244] = HAVE_ashrv4hi3;
  ena[245] = HAVE_ashrv2si3;
  ena[246] = HAVE_ashrv16qi3;
  ena[247] = HAVE_ashrv8hi3;
  ena[248] = HAVE_ashrv4si3;
  ena[249] = HAVE_ashrv2di3;
  ena[250] = HAVE_lshrsi3;
  ena[251] = HAVE_lshrdi3;
  ena[252] = HAVE_lshrv8qi3;
  ena[253] = HAVE_lshrv4hi3;
  ena[254] = HAVE_lshrv2si3;
  ena[255] = HAVE_lshrv16qi3;
  ena[256] = HAVE_lshrv8hi3;
  ena[257] = HAVE_lshrv4si3;
  ena[258] = HAVE_lshrv2di3;
  ena[259] = HAVE_rotlsi3;
  ena[260] = HAVE_rotldi3;
  ena[261] = HAVE_rotrsi3;
  ena[262] = HAVE_rotrdi3;
  ena[263] = HAVE_vashlv8qi3;
  ena[264] = HAVE_vashlv4hi3;
  ena[265] = HAVE_vashlv2si3;
  ena[266] = HAVE_vashlv16qi3;
  ena[267] = HAVE_vashlv8hi3;
  ena[268] = HAVE_vashlv4si3;
  ena[269] = HAVE_vashlv2di3;
  ena[270] = HAVE_vashrv8qi3;
  ena[271] = HAVE_vashrv4hi3;
  ena[272] = HAVE_vashrv2si3;
  ena[273] = HAVE_vashrv16qi3;
  ena[274] = HAVE_vashrv8hi3;
  ena[275] = HAVE_vashrv4si3;
  ena[276] = HAVE_vlshrv8qi3;
  ena[277] = HAVE_vlshrv4hi3;
  ena[278] = HAVE_vlshrv2si3;
  ena[279] = HAVE_vlshrv16qi3;
  ena[280] = HAVE_vlshrv8hi3;
  ena[281] = HAVE_vlshrv4si3;
  ena[282] = HAVE_sminsf3;
  ena[283] = HAVE_smindf3;
  ena[284] = HAVE_sminv8qi3;
  ena[285] = HAVE_sminv4hi3;
  ena[286] = HAVE_sminv2si3;
  ena[287] = HAVE_sminv16qi3;
  ena[288] = HAVE_sminv8hi3;
  ena[289] = HAVE_sminv4si3;
  ena[290] = HAVE_sminv2di3;
  ena[291] = HAVE_sminv2sf3;
  ena[292] = HAVE_sminv4sf3;
  ena[293] = HAVE_sminv2df3;
  ena[294] = HAVE_smaxsf3;
  ena[295] = HAVE_smaxdf3;
  ena[296] = HAVE_smaxv8qi3;
  ena[297] = HAVE_smaxv4hi3;
  ena[298] = HAVE_smaxv2si3;
  ena[299] = HAVE_smaxv16qi3;
  ena[300] = HAVE_smaxv8hi3;
  ena[301] = HAVE_smaxv4si3;
  ena[302] = HAVE_smaxv2di3;
  ena[303] = HAVE_smaxv2sf3;
  ena[304] = HAVE_smaxv4sf3;
  ena[305] = HAVE_smaxv2df3;
  ena[306] = HAVE_uminv8qi3;
  ena[307] = HAVE_uminv4hi3;
  ena[308] = HAVE_uminv2si3;
  ena[309] = HAVE_uminv16qi3;
  ena[310] = HAVE_uminv8hi3;
  ena[311] = HAVE_uminv4si3;
  ena[312] = HAVE_uminv2di3;
  ena[313] = HAVE_umaxv8qi3;
  ena[314] = HAVE_umaxv4hi3;
  ena[315] = HAVE_umaxv2si3;
  ena[316] = HAVE_umaxv16qi3;
  ena[317] = HAVE_umaxv8hi3;
  ena[318] = HAVE_umaxv4si3;
  ena[319] = HAVE_umaxv2di3;
  ena[320] = HAVE_negsi2;
  ena[321] = HAVE_negdi2;
  ena[322] = HAVE_negsf2;
  ena[323] = HAVE_negdf2;
  ena[324] = HAVE_negv8qi2;
  ena[325] = HAVE_negv4hi2;
  ena[326] = HAVE_negv2si2;
  ena[327] = HAVE_negv16qi2;
  ena[328] = HAVE_negv8hi2;
  ena[329] = HAVE_negv4si2;
  ena[330] = HAVE_negv2di2;
  ena[331] = HAVE_negv2sf2;
  ena[332] = HAVE_negv4sf2;
  ena[333] = HAVE_negv2df2;
  ena[334] = HAVE_abssi2;
  ena[335] = HAVE_absdi2;
  ena[336] = HAVE_abssf2;
  ena[337] = HAVE_absdf2;
  ena[338] = HAVE_absv8qi2;
  ena[339] = HAVE_absv4hi2;
  ena[340] = HAVE_absv2si2;
  ena[341] = HAVE_absv16qi2;
  ena[342] = HAVE_absv8hi2;
  ena[343] = HAVE_absv4si2;
  ena[344] = HAVE_absv2di2;
  ena[345] = HAVE_absv2sf2;
  ena[346] = HAVE_absv4sf2;
  ena[347] = HAVE_absv2df2;
  ena[348] = HAVE_one_cmplsi2;
  ena[349] = HAVE_one_cmpldi2;
  ena[350] = HAVE_one_cmplv8qi2;
  ena[351] = HAVE_one_cmplv4hi2;
  ena[352] = HAVE_one_cmplv2si2;
  ena[353] = HAVE_one_cmplv16qi2;
  ena[354] = HAVE_one_cmplv8hi2;
  ena[355] = HAVE_one_cmplv4si2;
  ena[356] = HAVE_one_cmplv2di2;
  ena[357] = HAVE_bswaphi2;
  ena[358] = HAVE_bswapsi2;
  ena[359] = HAVE_bswapdi2;
  ena[360] = HAVE_bswapv4hi2;
  ena[361] = HAVE_bswapv2si2;
  ena[362] = HAVE_bswapv8hi2;
  ena[363] = HAVE_bswapv4si2;
  ena[364] = HAVE_bswapv2di2;
  ena[365] = HAVE_ffssi2;
  ena[366] = HAVE_ffsdi2;
  ena[367] = HAVE_clzsi2;
  ena[368] = HAVE_clzdi2;
  ena[369] = HAVE_clzv8qi2;
  ena[370] = HAVE_clzv4hi2;
  ena[371] = HAVE_clzv2si2;
  ena[372] = HAVE_clzv16qi2;
  ena[373] = HAVE_clzv8hi2;
  ena[374] = HAVE_clzv4si2;
  ena[375] = HAVE_ctzsi2;
  ena[376] = HAVE_ctzdi2;
  ena[377] = HAVE_ctzv2si2;
  ena[378] = HAVE_ctzv4si2;
  ena[379] = HAVE_clrsbsi2;
  ena[380] = HAVE_clrsbdi2;
  ena[381] = HAVE_clrsbv8qi2;
  ena[382] = HAVE_clrsbv4hi2;
  ena[383] = HAVE_clrsbv2si2;
  ena[384] = HAVE_clrsbv16qi2;
  ena[385] = HAVE_clrsbv8hi2;
  ena[386] = HAVE_clrsbv4si2;
  ena[387] = HAVE_popcountv8qi2;
  ena[388] = HAVE_popcountv16qi2;
  ena[389] = HAVE_sqrtsf2;
  ena[390] = HAVE_sqrtdf2;
  ena[391] = HAVE_sqrtv2sf2;
  ena[392] = HAVE_sqrtv4sf2;
  ena[393] = HAVE_sqrtv2df2;
  ena[394] = HAVE_movqi;
  ena[395] = HAVE_movhi;
  ena[396] = HAVE_movsi;
  ena[397] = HAVE_movdi;
  ena[398] = HAVE_movti;
  ena[399] = HAVE_movoi;
  ena[400] = HAVE_movci;
  ena[401] = HAVE_movxi;
  ena[402] = HAVE_movhf;
  ena[403] = HAVE_movsf;
  ena[404] = HAVE_movdf;
  ena[405] = HAVE_movtf;
  ena[406] = HAVE_movv8qi;
  ena[407] = HAVE_movv4hi;
  ena[408] = HAVE_movv2si;
  ena[409] = HAVE_movv16qi;
  ena[410] = HAVE_movv8hi;
  ena[411] = HAVE_movv4si;
  ena[412] = HAVE_movv2di;
  ena[413] = HAVE_movv4hf;
  ena[414] = HAVE_movv2sf;
  ena[415] = HAVE_movv8hf;
  ena[416] = HAVE_movv4sf;
  ena[417] = HAVE_movv2df;
  ena[418] = HAVE_movmisalignv8qi;
  ena[419] = HAVE_movmisalignv4hi;
  ena[420] = HAVE_movmisalignv2si;
  ena[421] = HAVE_movmisalignv16qi;
  ena[422] = HAVE_movmisalignv8hi;
  ena[423] = HAVE_movmisalignv4si;
  ena[424] = HAVE_movmisalignv2di;
  ena[425] = HAVE_movmisalignv2sf;
  ena[426] = HAVE_movmisalignv4sf;
  ena[427] = HAVE_movmisalignv2df;
  ena[428] = HAVE_insvsi;
  ena[429] = HAVE_insvdi;
  ena[430] = HAVE_cbranchcc4;
  ena[431] = HAVE_cbranchsi4;
  ena[432] = HAVE_cbranchdi4;
  ena[433] = HAVE_cbranchsf4;
  ena[434] = HAVE_cbranchdf4;
  ena[435] = HAVE_negsicc;
  ena[436] = HAVE_negdicc;
  ena[437] = HAVE_notsicc;
  ena[438] = HAVE_notdicc;
  ena[439] = HAVE_movqicc;
  ena[440] = HAVE_movhicc;
  ena[441] = HAVE_movsicc;
  ena[442] = HAVE_movdicc;
  ena[443] = HAVE_movsfcc;
  ena[444] = HAVE_movdfcc;
  ena[445] = HAVE_cmovsi6;
  ena[446] = HAVE_cmovdi6;
  ena[447] = HAVE_cmovsf6;
  ena[448] = HAVE_cmovdf6;
  ena[449] = HAVE_cstorecc4;
  ena[450] = HAVE_cstoresi4;
  ena[451] = HAVE_cstoredi4;
  ena[452] = HAVE_cstoresf4;
  ena[453] = HAVE_cstoredf4;
  ena[454] = HAVE_smuldi3_highpart;
  ena[455] = HAVE_umuldi3_highpart;
  ena[456] = HAVE_movmemdi;
  ena[457] = HAVE_fmasf4;
  ena[458] = HAVE_fmadf4;
  ena[459] = HAVE_fmav2sf4;
  ena[460] = HAVE_fmav4sf4;
  ena[461] = HAVE_fmav2df4;
  ena[462] = HAVE_fmssf4;
  ena[463] = HAVE_fmsdf4;
  ena[464] = HAVE_fnmasf4;
  ena[465] = HAVE_fnmadf4;
  ena[466] = HAVE_fnmav2sf4;
  ena[467] = HAVE_fnmav4sf4;
  ena[468] = HAVE_fnmav2df4;
  ena[469] = HAVE_fnmssf4;
  ena[470] = HAVE_fnmsdf4;
  ena[471] = HAVE_rintsf2;
  ena[472] = HAVE_rintdf2;
  ena[473] = HAVE_rintv2sf2;
  ena[474] = HAVE_rintv4sf2;
  ena[475] = HAVE_rintv2df2;
  ena[476] = HAVE_roundsf2;
  ena[477] = HAVE_rounddf2;
  ena[478] = HAVE_roundv2sf2;
  ena[479] = HAVE_roundv4sf2;
  ena[480] = HAVE_roundv2df2;
  ena[481] = HAVE_floorsf2;
  ena[482] = HAVE_floordf2;
  ena[483] = HAVE_floorv2sf2;
  ena[484] = HAVE_floorv4sf2;
  ena[485] = HAVE_floorv2df2;
  ena[486] = HAVE_ceilsf2;
  ena[487] = HAVE_ceildf2;
  ena[488] = HAVE_ceilv2sf2;
  ena[489] = HAVE_ceilv4sf2;
  ena[490] = HAVE_ceilv2df2;
  ena[491] = HAVE_btruncsf2;
  ena[492] = HAVE_btruncdf2;
  ena[493] = HAVE_btruncv2sf2;
  ena[494] = HAVE_btruncv4sf2;
  ena[495] = HAVE_btruncv2df2;
  ena[496] = HAVE_nearbyintsf2;
  ena[497] = HAVE_nearbyintdf2;
  ena[498] = HAVE_nearbyintv2sf2;
  ena[499] = HAVE_nearbyintv4sf2;
  ena[500] = HAVE_nearbyintv2df2;
  ena[501] = HAVE_copysignsf3;
  ena[502] = HAVE_copysigndf3;
  ena[503] = HAVE_rsqrtsf2;
  ena[504] = HAVE_rsqrtdf2;
  ena[505] = HAVE_rsqrtv2sf2;
  ena[506] = HAVE_rsqrtv4sf2;
  ena[507] = HAVE_rsqrtv2df2;
  ena[508] = HAVE_fmaxsf3;
  ena[509] = HAVE_fmaxdf3;
  ena[510] = HAVE_fmaxv2sf3;
  ena[511] = HAVE_fmaxv4sf3;
  ena[512] = HAVE_fmaxv2df3;
  ena[513] = HAVE_fminsf3;
  ena[514] = HAVE_fmindf3;
  ena[515] = HAVE_fminv2sf3;
  ena[516] = HAVE_fminv4sf3;
  ena[517] = HAVE_fminv2df3;
  ena[518] = HAVE_reduc_smax_scal_v8qi;
  ena[519] = HAVE_reduc_smax_scal_v4hi;
  ena[520] = HAVE_reduc_smax_scal_v2si;
  ena[521] = HAVE_reduc_smax_scal_v16qi;
  ena[522] = HAVE_reduc_smax_scal_v8hi;
  ena[523] = HAVE_reduc_smax_scal_v4si;
  ena[524] = HAVE_reduc_smax_scal_v2sf;
  ena[525] = HAVE_reduc_smax_scal_v4sf;
  ena[526] = HAVE_reduc_smax_scal_v2df;
  ena[527] = HAVE_reduc_smin_scal_v8qi;
  ena[528] = HAVE_reduc_smin_scal_v4hi;
  ena[529] = HAVE_reduc_smin_scal_v2si;
  ena[530] = HAVE_reduc_smin_scal_v16qi;
  ena[531] = HAVE_reduc_smin_scal_v8hi;
  ena[532] = HAVE_reduc_smin_scal_v4si;
  ena[533] = HAVE_reduc_smin_scal_v2sf;
  ena[534] = HAVE_reduc_smin_scal_v4sf;
  ena[535] = HAVE_reduc_smin_scal_v2df;
  ena[536] = HAVE_reduc_plus_scal_v8qi;
  ena[537] = HAVE_reduc_plus_scal_v4hi;
  ena[538] = HAVE_reduc_plus_scal_v2si;
  ena[539] = HAVE_reduc_plus_scal_v16qi;
  ena[540] = HAVE_reduc_plus_scal_v8hi;
  ena[541] = HAVE_reduc_plus_scal_v4si;
  ena[542] = HAVE_reduc_plus_scal_v2di;
  ena[543] = HAVE_reduc_plus_scal_v2sf;
  ena[544] = HAVE_reduc_plus_scal_v4sf;
  ena[545] = HAVE_reduc_plus_scal_v2df;
  ena[546] = HAVE_reduc_umax_scal_v8qi;
  ena[547] = HAVE_reduc_umax_scal_v4hi;
  ena[548] = HAVE_reduc_umax_scal_v2si;
  ena[549] = HAVE_reduc_umax_scal_v16qi;
  ena[550] = HAVE_reduc_umax_scal_v8hi;
  ena[551] = HAVE_reduc_umax_scal_v4si;
  ena[552] = HAVE_reduc_umin_scal_v8qi;
  ena[553] = HAVE_reduc_umin_scal_v4hi;
  ena[554] = HAVE_reduc_umin_scal_v2si;
  ena[555] = HAVE_reduc_umin_scal_v16qi;
  ena[556] = HAVE_reduc_umin_scal_v8hi;
  ena[557] = HAVE_reduc_umin_scal_v4si;
  ena[558] = HAVE_widen_ssumv8qi3;
  ena[559] = HAVE_widen_ssumv4hi3;
  ena[560] = HAVE_widen_ssumv2si3;
  ena[561] = HAVE_widen_ssumv16qi3;
  ena[562] = HAVE_widen_ssumv8hi3;
  ena[563] = HAVE_widen_ssumv4si3;
  ena[564] = HAVE_widen_usumv8qi3;
  ena[565] = HAVE_widen_usumv4hi3;
  ena[566] = HAVE_widen_usumv2si3;
  ena[567] = HAVE_widen_usumv16qi3;
  ena[568] = HAVE_widen_usumv8hi3;
  ena[569] = HAVE_widen_usumv4si3;
  ena[570] = HAVE_vec_extractv8qi;
  ena[571] = HAVE_vec_extractv4hi;
  ena[572] = HAVE_vec_extractv2si;
  ena[573] = HAVE_vec_extractv16qi;
  ena[574] = HAVE_vec_extractv8hi;
  ena[575] = HAVE_vec_extractv4si;
  ena[576] = HAVE_vec_extractv2di;
  ena[577] = HAVE_vec_extractv4hf;
  ena[578] = HAVE_vec_extractv2sf;
  ena[579] = HAVE_vec_extractv8hf;
  ena[580] = HAVE_vec_extractv4sf;
  ena[581] = HAVE_vec_extractv2df;
  ena[582] = HAVE_vec_initv8qi;
  ena[583] = HAVE_vec_initv4hi;
  ena[584] = HAVE_vec_initv2si;
  ena[585] = HAVE_vec_initv16qi;
  ena[586] = HAVE_vec_initv8hi;
  ena[587] = HAVE_vec_initv4si;
  ena[588] = HAVE_vec_initv2di;
  ena[589] = HAVE_vec_initv4hf;
  ena[590] = HAVE_vec_initv2sf;
  ena[591] = HAVE_vec_initv8hf;
  ena[592] = HAVE_vec_initv4sf;
  ena[593] = HAVE_vec_initv2df;
  ena[594] = HAVE_vec_pack_trunc_di;
  ena[595] = HAVE_vec_pack_trunc_df;
  ena[596] = HAVE_vec_pack_trunc_v4hi;
  ena[597] = HAVE_vec_pack_trunc_v2si;
  ena[598] = HAVE_vec_pack_trunc_v8hi;
  ena[599] = HAVE_vec_pack_trunc_v4si;
  ena[600] = HAVE_vec_pack_trunc_v2di;
  ena[601] = HAVE_vec_pack_trunc_v2df;
  ena[602] = HAVE_vec_perm_constv8qi;
  ena[603] = HAVE_vec_perm_constv4hi;
  ena[604] = HAVE_vec_perm_constv2si;
  ena[605] = HAVE_vec_perm_constv16qi;
  ena[606] = HAVE_vec_perm_constv8hi;
  ena[607] = HAVE_vec_perm_constv4si;
  ena[608] = HAVE_vec_perm_constv2di;
  ena[609] = HAVE_vec_perm_constv4hf;
  ena[610] = HAVE_vec_perm_constv2sf;
  ena[611] = HAVE_vec_perm_constv8hf;
  ena[612] = HAVE_vec_perm_constv4sf;
  ena[613] = HAVE_vec_perm_constv2df;
  ena[614] = HAVE_vec_permv8qi;
  ena[615] = HAVE_vec_permv16qi;
  ena[616] = HAVE_vec_setv8qi;
  ena[617] = HAVE_vec_setv4hi;
  ena[618] = HAVE_vec_setv2si;
  ena[619] = HAVE_vec_setv16qi;
  ena[620] = HAVE_vec_setv8hi;
  ena[621] = HAVE_vec_setv4si;
  ena[622] = HAVE_vec_setv2di;
  ena[623] = HAVE_vec_setv4hf;
  ena[624] = HAVE_vec_setv2sf;
  ena[625] = HAVE_vec_setv8hf;
  ena[626] = HAVE_vec_setv4sf;
  ena[627] = HAVE_vec_setv2df;
  ena[628] = HAVE_vec_shr_v8qi;
  ena[629] = HAVE_vec_shr_v4hi;
  ena[630] = HAVE_vec_shr_v2si;
  ena[631] = HAVE_vec_shr_v4hf;
  ena[632] = HAVE_vec_shr_v2sf;
  ena[633] = HAVE_vec_unpacks_hi_v16qi;
  ena[634] = HAVE_vec_unpacks_hi_v8hi;
  ena[635] = HAVE_vec_unpacks_hi_v4si;
  ena[636] = HAVE_vec_unpacks_hi_v8hf;
  ena[637] = HAVE_vec_unpacks_hi_v4sf;
  ena[638] = HAVE_vec_unpacks_lo_v16qi;
  ena[639] = HAVE_vec_unpacks_lo_v8hi;
  ena[640] = HAVE_vec_unpacks_lo_v4si;
  ena[641] = HAVE_vec_unpacks_lo_v8hf;
  ena[642] = HAVE_vec_unpacks_lo_v4sf;
  ena[643] = HAVE_vec_unpacku_hi_v16qi;
  ena[644] = HAVE_vec_unpacku_hi_v8hi;
  ena[645] = HAVE_vec_unpacku_hi_v4si;
  ena[646] = HAVE_vec_unpacku_lo_v16qi;
  ena[647] = HAVE_vec_unpacku_lo_v8hi;
  ena[648] = HAVE_vec_unpacku_lo_v4si;
  ena[649] = HAVE_vec_widen_smult_hi_v16qi;
  ena[650] = HAVE_vec_widen_smult_hi_v8hi;
  ena[651] = HAVE_vec_widen_smult_hi_v4si;
  ena[652] = HAVE_vec_widen_smult_lo_v16qi;
  ena[653] = HAVE_vec_widen_smult_lo_v8hi;
  ena[654] = HAVE_vec_widen_smult_lo_v4si;
  ena[655] = HAVE_vec_widen_umult_hi_v16qi;
  ena[656] = HAVE_vec_widen_umult_hi_v8hi;
  ena[657] = HAVE_vec_widen_umult_hi_v4si;
  ena[658] = HAVE_vec_widen_umult_lo_v16qi;
  ena[659] = HAVE_vec_widen_umult_lo_v8hi;
  ena[660] = HAVE_vec_widen_umult_lo_v4si;
  ena[661] = HAVE_atomic_add_fetchqi;
  ena[662] = HAVE_atomic_add_fetchhi;
  ena[663] = HAVE_atomic_add_fetchsi;
  ena[664] = HAVE_atomic_add_fetchdi;
  ena[665] = HAVE_atomic_addqi;
  ena[666] = HAVE_atomic_addhi;
  ena[667] = HAVE_atomic_addsi;
  ena[668] = HAVE_atomic_adddi;
  ena[669] = HAVE_atomic_and_fetchqi;
  ena[670] = HAVE_atomic_and_fetchhi;
  ena[671] = HAVE_atomic_and_fetchsi;
  ena[672] = HAVE_atomic_and_fetchdi;
  ena[673] = HAVE_atomic_andqi;
  ena[674] = HAVE_atomic_andhi;
  ena[675] = HAVE_atomic_andsi;
  ena[676] = HAVE_atomic_anddi;
  ena[677] = HAVE_atomic_compare_and_swapqi;
  ena[678] = HAVE_atomic_compare_and_swaphi;
  ena[679] = HAVE_atomic_compare_and_swapsi;
  ena[680] = HAVE_atomic_compare_and_swapdi;
  ena[681] = HAVE_atomic_exchangeqi;
  ena[682] = HAVE_atomic_exchangehi;
  ena[683] = HAVE_atomic_exchangesi;
  ena[684] = HAVE_atomic_exchangedi;
  ena[685] = HAVE_atomic_fetch_addqi;
  ena[686] = HAVE_atomic_fetch_addhi;
  ena[687] = HAVE_atomic_fetch_addsi;
  ena[688] = HAVE_atomic_fetch_adddi;
  ena[689] = HAVE_atomic_fetch_andqi;
  ena[690] = HAVE_atomic_fetch_andhi;
  ena[691] = HAVE_atomic_fetch_andsi;
  ena[692] = HAVE_atomic_fetch_anddi;
  ena[693] = HAVE_atomic_fetch_nandqi;
  ena[694] = HAVE_atomic_fetch_nandhi;
  ena[695] = HAVE_atomic_fetch_nandsi;
  ena[696] = HAVE_atomic_fetch_nanddi;
  ena[697] = HAVE_atomic_fetch_orqi;
  ena[698] = HAVE_atomic_fetch_orhi;
  ena[699] = HAVE_atomic_fetch_orsi;
  ena[700] = HAVE_atomic_fetch_ordi;
  ena[701] = HAVE_atomic_fetch_subqi;
  ena[702] = HAVE_atomic_fetch_subhi;
  ena[703] = HAVE_atomic_fetch_subsi;
  ena[704] = HAVE_atomic_fetch_subdi;
  ena[705] = HAVE_atomic_fetch_xorqi;
  ena[706] = HAVE_atomic_fetch_xorhi;
  ena[707] = HAVE_atomic_fetch_xorsi;
  ena[708] = HAVE_atomic_fetch_xordi;
  ena[709] = HAVE_atomic_loadqi;
  ena[710] = HAVE_atomic_loadhi;
  ena[711] = HAVE_atomic_loadsi;
  ena[712] = HAVE_atomic_loaddi;
  ena[713] = HAVE_atomic_nand_fetchqi;
  ena[714] = HAVE_atomic_nand_fetchhi;
  ena[715] = HAVE_atomic_nand_fetchsi;
  ena[716] = HAVE_atomic_nand_fetchdi;
  ena[717] = HAVE_atomic_nandqi;
  ena[718] = HAVE_atomic_nandhi;
  ena[719] = HAVE_atomic_nandsi;
  ena[720] = HAVE_atomic_nanddi;
  ena[721] = HAVE_atomic_or_fetchqi;
  ena[722] = HAVE_atomic_or_fetchhi;
  ena[723] = HAVE_atomic_or_fetchsi;
  ena[724] = HAVE_atomic_or_fetchdi;
  ena[725] = HAVE_atomic_orqi;
  ena[726] = HAVE_atomic_orhi;
  ena[727] = HAVE_atomic_orsi;
  ena[728] = HAVE_atomic_ordi;
  ena[729] = HAVE_atomic_storeqi;
  ena[730] = HAVE_atomic_storehi;
  ena[731] = HAVE_atomic_storesi;
  ena[732] = HAVE_atomic_storedi;
  ena[733] = HAVE_atomic_sub_fetchqi;
  ena[734] = HAVE_atomic_sub_fetchhi;
  ena[735] = HAVE_atomic_sub_fetchsi;
  ena[736] = HAVE_atomic_sub_fetchdi;
  ena[737] = HAVE_atomic_subqi;
  ena[738] = HAVE_atomic_subhi;
  ena[739] = HAVE_atomic_subsi;
  ena[740] = HAVE_atomic_subdi;
  ena[741] = HAVE_atomic_xor_fetchqi;
  ena[742] = HAVE_atomic_xor_fetchhi;
  ena[743] = HAVE_atomic_xor_fetchsi;
  ena[744] = HAVE_atomic_xor_fetchdi;
  ena[745] = HAVE_atomic_xorqi;
  ena[746] = HAVE_atomic_xorhi;
  ena[747] = HAVE_atomic_xorsi;
  ena[748] = HAVE_atomic_xordi;
  ena[749] = HAVE_get_thread_pointerdi;
}

static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 16) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '4', "divmod", gen_int_libfunc },
  { '4', "udivmod", gen_int_libfunc },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

